LeetCode – Two Sum (Java)

Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution.
Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Subscribe to see which companies asked this question。

读完这个题目的时候很快就想到两个循环去做这个题,时间复杂度是O(n^2)。先把这个写出来

    public static int[] twoSum(int[] nums, int target) {
    	int[] indexs = new int[2];
    	for(int i=0;i<nums.length;i++){
    		for(int j=i+1;j<nums.length;j++){
    			if(nums[i]+nums[j]==target){
    				indexs[0]=i+1;
    				indexs[1]=j+1;
    			}
    		}
    	}
        return indexs;
    }

但是这个题目肯定还有更简单的解法,想了一会没有想到解决的方法,于是在网上搜了一下,果然有更简单的方法。发现我在读题的时候忽略了一个条件,这里给出的数组是有序的,也就是说小的数是在前边的,而大的数一定是在后边的。如果一个数是另两个数的和那么一定是一前一后的。

 public int[] twoSum(int[] numbers, int target) {
	HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
	int[] result = new int[2];
 
	for (int i = 0; i < numbers.length; i++) {
		if (map.containsKey(numbers[i])) {
			int index = map.get(numbers[i]);
			result[0] = index+1 ;
			result[1] = i+1;
			break;
		} else {
			map.put(target - numbers[i], i);
		}
	}
 
	return result;
    }

但是如果这个数组是无须的呢,有没有O(n)的解法呢?

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值